From: Robin Cornelius <robin.cornelius@gmail.com>
Subject: [PATCH] topic/features/jira-backported/VWR-7531-Dynamic-Grid-List

<patch description>

Signed-off-by: Robin Cornelius <robin.cornelius@gmail.com>

---
 indra/newview/app_settings/grids.xml    |   24 +++
 indra/newview/app_settings/settings.xml |    2 +-
 indra/newview/llappviewer.cpp           |   25 ---
 indra/newview/llpanellogin.cpp          |  122 ++-------------
 indra/newview/llstartup.cpp             |    6 +-
 indra/newview/llviewernetwork.cpp       |  260 +++++++++++++++----------------
 indra/newview/llviewernetwork.h         |   48 ++----
 7 files changed, 186 insertions(+), 301 deletions(-)

diff --git a/indra/newview/app_settings/grids.xml b/indra/newview/app_settings/grids.xml
new file mode 100644
index 0000000..24d1183
--- /dev/null
+++ b/indra/newview/app_settings/grids.xml
@@ -0,0 +1,24 @@
+<?xml version="1.0" encoding="utf-8" standalone="yes"?>
+<!-- this is the LLSD version -->
+<llsd>
+	<map>
+		<key>grids</key>
+		<array>
+			<map>
+				<key>name</key><string>util.aditi.lindenlab.com</string>
+				<key>label</key><string>Aditi</string>
+				<key>login_uri</key><string>https://login.aditi.lindenlab.com/cgi-bin/login.cgi</string>
+				<key>helper_uri</key><string>http://aditi-secondlife.webdev.lindenlab.com/helpers/</string>
+                                <key>login_page</key><string>http://secondlife.com/app/login/</string>
+			</map>
+			<map>
+				<key>name</key><string>osgrid</string>
+				<key>label</key><string>OSGrid</string>
+				<key>login_uri</key><string>http://osgrid.org:8002</string>
+				<key>helper_uri</key><string>http://osgrid.org/loginpage.htm</string>
+				<key>menu_color</key><string>green</string>
+                                <key>login_page</key><string>http://osgrid.org/</string>
+			</map>
+		</array>
+	</map>
+</llsd>
diff --git a/indra/newview/app_settings/settings.xml b/indra/newview/app_settings/settings.xml
index 27eacfb..9560f79 100644
--- a/indra/newview/app_settings/settings.xml
+++ b/indra/newview/app_settings/settings.xml
@@ -3587,7 +3587,7 @@
       <key>Type</key>
       <string>Boolean</string>
       <key>Value</key>
-      <integer>0</integer>
+      <integer>1</integer>
     </map>
     <key>ForceMandatoryUpdate</key>
     <map>
diff --git a/indra/newview/llappviewer.cpp b/indra/newview/llappviewer.cpp
index 09d1141..d93e503 100644
--- a/indra/newview/llappviewer.cpp
+++ b/indra/newview/llappviewer.cpp
@@ -453,31 +453,6 @@ static void settings_modify()
 
 void LLAppViewer::initGridChoice()
 {
-	// Load	up the initial grid	choice from:
-	//	- hard coded defaults...
-	//	- command line settings...
-	//	- if dev build,	persisted settings...
-
-	// Set the "grid choice", this is specified	by command line.
-	std::string	grid_choice	= gSavedSettings.getString("CmdLineGridChoice");
-	LLViewerLogin::getInstance()->setGridChoice(grid_choice);
-
-	// Load last server choice by default 
-	// ignored if the command line grid	choice has been	set
-	if(grid_choice.empty())
-	{
-		S32	server = gSavedSettings.getS32("ServerChoice");
-		server = llclamp(server, 0,	(S32)GRID_INFO_COUNT - 1);
-		if(server == GRID_INFO_OTHER)
-		{
-			std::string custom_server = gSavedSettings.getString("CustomServer");
-			LLViewerLogin::getInstance()->setGridChoice(custom_server);
-		}
-		else if(server != (S32)GRID_INFO_NONE)
-		{
-			LLViewerLogin::getInstance()->setGridChoice((EGridInfo)server);
-		}
-	}
 }
 
 //virtual
diff --git a/indra/newview/llpanellogin.cpp b/indra/newview/llpanellogin.cpp
index 64eecd6..268ec23 100644
--- a/indra/newview/llpanellogin.cpp
+++ b/indra/newview/llpanellogin.cpp
@@ -131,103 +131,8 @@ void LLLoginHandler::parse(const LLSD& queryMap)
 	mWebLoginKey = queryMap["web_login_key"].asUUID();
 	mFirstName = queryMap["first_name"].asString();
 	mLastName = queryMap["last_name"].asString();
-	
-	EGridInfo grid_choice = GRID_INFO_NONE;
-	if (queryMap["grid"].asString() == "aditi")
-	{
-		grid_choice = GRID_INFO_ADITI;
-	}
-	else if (queryMap["grid"].asString() == "agni")
-	{
-		grid_choice = GRID_INFO_AGNI;
-	}
-	else if (queryMap["grid"].asString() == "siva")
-	{
-		grid_choice = GRID_INFO_SIVA;
-	}
-	else if (queryMap["grid"].asString() == "damballah")
-	{
-		grid_choice = GRID_INFO_DAMBALLAH;
-	}
-	else if (queryMap["grid"].asString() == "durga")
-	{
-		grid_choice = GRID_INFO_DURGA;
-	}
-	else if (queryMap["grid"].asString() == "shakti")
-	{
-		grid_choice = GRID_INFO_SHAKTI;
-	}
-	else if (queryMap["grid"].asString() == "soma")
-	{
-		grid_choice = GRID_INFO_SOMA;
-	}
-	else if (queryMap["grid"].asString() == "ganga")
-	{
-		grid_choice = GRID_INFO_GANGA;
-	}
-	else if (queryMap["grid"].asString() == "vaak")
-	{
-		grid_choice = GRID_INFO_VAAK;
-	}
-	else if (queryMap["grid"].asString() == "uma")
-	{
-		grid_choice = GRID_INFO_UMA;
-	}
-	else if (queryMap["grid"].asString() == "mohini")
-	{
-		grid_choice = GRID_INFO_MOHINI;
-	}
-	else if (queryMap["grid"].asString() == "yami")
-	{
-		grid_choice = GRID_INFO_YAMI;
-	}
-	else if (queryMap["grid"].asString() == "nandi")
-	{
-		grid_choice = GRID_INFO_NANDI;
-	}
-	else if (queryMap["grid"].asString() == "mitra")
-	{
-		grid_choice = GRID_INFO_MITRA;
-	}
-	else if (queryMap["grid"].asString() == "radha")
-	{
-		grid_choice = GRID_INFO_RADHA;
-	}
-	else if (queryMap["grid"].asString() == "ravi")
-	{
-		grid_choice = GRID_INFO_RAVI;
-	}
-	else if (queryMap["grid"].asString() == "aruna")
-	{
-		grid_choice = GRID_INFO_ARUNA;
-	}
-	else if (queryMap["grid"].asString() == "bharati")
-	{
-		grid_choice = GRID_INFO_BHARATI;
-	}
-	else if (queryMap["grid"].asString() == "chandra")
-	{
-		grid_choice = GRID_INFO_CHANDRA;
-	}
-	else if (queryMap["grid"].asString() == "danu")
-	{
-		grid_choice = GRID_INFO_DANU;
-	}
-	else if (queryMap["grid"].asString() == "parvati")
-	{
-		grid_choice = GRID_INFO_PARVATI;
-	}
-	else if (queryMap["grid"].asString() == "skanda")
-	{
-		grid_choice = GRID_INFO_SKANDA;
-	}
 
-	if(grid_choice != GRID_INFO_NONE)
-	{
-		LLViewerLogin::getInstance()->setGridChoice(grid_choice);
-	}
-
-	std::string startLocation = queryMap["location"].asString();
+ 	std::string startLocation = queryMap["location"].asString();
 
 	if (startLocation == "specify")
 	{
@@ -909,11 +814,8 @@ void LLPanelLogin::loadLoginPage()
 	
 	std::ostringstream oStr;
 
-	std::string login_page = gSavedSettings.getString("LoginPage");
-	if (login_page.empty())
-	{
-		login_page = sInstance->getString( "real_url" );
-	}
+	std::string login_page=LLViewerLogin::getInstance()->getGridPage();
+
 	oStr << login_page;
 	
 	// Use the right delimeter depending on how LLURI parses the URL
@@ -953,6 +855,7 @@ void LLPanelLogin::loadLoginPage()
 	curl_free(curl_grid);
 
 	gViewerWindow->setMenuBackgroundColor(false, !LLViewerLogin::getInstance()->isInProductionGrid());
+	LLViewerLogin::getInstance()->setMenuColor();
 	gLoginMenuBarView->setBackgroundColor(gMenuBarView->getBackgroundColor());
 
 
@@ -1175,7 +1078,7 @@ void LLPanelLogin::onSelectServer(LLUICtrl*, void*)
 	{
 		grid_index = combo->getValue().asInteger();
 
-		if ((S32)GRID_INFO_OTHER == grid_index)
+		if ((S32)LLViewerLogin::getInstance()->getGridCount() == grid_index)
 		{
 			// This happens if the user specifies a custom grid
 			// via command line.
@@ -1185,7 +1088,7 @@ void LLPanelLogin::onSelectServer(LLUICtrl*, void*)
 	else
 	{
 		// no valid selection, return other
-		grid_index = (S32)GRID_INFO_OTHER;
+		grid_index = (S32)LLViewerLogin::getInstance()->getGridCount();
 		grid_label = combo_val.asString();
 	}
 
@@ -1193,15 +1096,24 @@ void LLPanelLogin::onSelectServer(LLUICtrl*, void*)
 	// from the command line.
 	LLViewerLogin* vl = LLViewerLogin::getInstance();
 	vl->resetURIs();
-	if(grid_index != GRID_INFO_OTHER)
+	if(grid_index != LLViewerLogin::getInstance()->getGridCount())
 	{
-		vl->setGridChoice((EGridInfo)grid_index);
+		vl->setGridChoice(grid_index);
 	}
 	else
 	{
 		vl->setGridChoice(grid_label);
 	}
 
+	// clear the password if we are switching grids so we don't send
+	// the wrong pass to the wrong grid.
+	if (sInstance)
+	{
+		// no method to clear a text box?
+		const std::string nothing("");
+		sInstance->childSetText("password_edit", nothing);		
+	}	
+	
 	// grid changed so show new splash screen (possibly)
 	loadLoginPage();
 }
diff --git a/indra/newview/llstartup.cpp b/indra/newview/llstartup.cpp
index 5f25dc3..92bd3d1 100644
--- a/indra/newview/llstartup.cpp
+++ b/indra/newview/llstartup.cpp
@@ -2525,12 +2525,12 @@ void login_show()
 	
 	LL_DEBUGS("AppInit") << "Setting Servers" << LL_ENDL;
 
-	LLPanelLogin::addServer(LLViewerLogin::getInstance()->getGridLabel(), LLViewerLogin::getInstance()->getGridChoice());
+	//LLPanelLogin::addServer(LLViewerLogin::getInstance()->getGridLabel(), LLViewerLogin::getInstance()->getGridChoice());
 
 	LLViewerLogin* vl = LLViewerLogin::getInstance();
-	for(int grid_index = GRID_INFO_ADITI; grid_index < GRID_INFO_OTHER; ++grid_index)
+	for(int grid_index = 1; grid_index < LLViewerLogin::getInstance()->getGridCount() ; ++grid_index)
 	{
-		LLPanelLogin::addServer(vl->getKnownGridLabel((EGridInfo)grid_index), grid_index);
+		LLPanelLogin::addServer(vl->getKnownGridLabel(grid_index).c_str(), grid_index);
 	}
 }
 
diff --git a/indra/newview/llviewernetwork.cpp b/indra/newview/llviewernetwork.cpp
index 1830b76..22a05c0 100644
--- a/indra/newview/llviewernetwork.cpp
+++ b/indra/newview/llviewernetwork.cpp
@@ -34,148 +34,126 @@
 
 #include "llviewernetwork.h"
 #include "llviewercontrol.h"
+#include "llsd.h"
+#include "llsdserialize.h"
+#include "llviewermenu.h"
 
-struct LLGridData
-{
-	const char* mLabel;
-	const char* mName;
-	const char* mLoginURI;
-	const char* mHelperURI;
-};
+const int DEFAULT_GRID_CHOICE=1;
+const int GRID_INFO_NONE=0;
 
-static LLGridData gGridInfo[GRID_INFO_COUNT] = 
-{
-	{ "None", "", "", ""},
-	{ "Aditi", 
-	  "util.aditi.lindenlab.com", 
-	  "https://login.aditi.lindenlab.com/cgi-bin/login.cgi",
-	  "http://aditi-secondlife.webdev.lindenlab.com/helpers/" },
-	{ "Agni", 
-	  "util.agni.lindenlab.com", 
-	  "https://login.agni.lindenlab.com/cgi-bin/login.cgi",
-	  "https://secondlife.com/helpers/" },
-	{ "Aruna",
-	  "util.aruna.lindenlab.com",
-	  "https://login.aruna.lindenlab.com/cgi-bin/login.cgi",
-	  "http://aruna-secondlife.webdev.lindenlab.com/helpers/" },
-	{ "Bharati",
-	  "util.bharati.lindenlab.com",
-	  "https://login.bharati.lindenlab.com/cgi-bin/login.cgi",
-	  "http://bharati-secondlife.webdev.lindenlab.com/helpers/" },
-	{ "Chandra",
-	  "util.chandra.lindenlab.com",
-	  "https://login.chandra.lindenlab.com/cgi-bin/login.cgi",
-	  "http://chandra-secondlife.webdev.lindenlab.com/helpers/" },
-	{ "Damballah",
-	  "util.damballah.lindenlab.com",
-	  "https://login.damballah.lindenlab.com/cgi-bin/login.cgi",
-	  "http://damballah-secondlife.webdev.lindenlab.com/helpers/" },
-	{ "Danu",
-	  "util.danu.lindenlab.com",
-	  "https://login.danu.lindenlab.com/cgi-bin/login.cgi",
-	  "http://danu-secondlife.webdev.lindenlab.com/helpers/" },
-	{ "Durga",
-	  "util.durga.lindenlab.com",
-	  "https://login.durga.lindenlab.com/cgi-bin/login.cgi",
-	  "http://durga-secondlife.webdev.lindenlab.com/helpers/" },
-	{ "Ganga",
-	  "util.ganga.lindenlab.com",
-	  "https://login.ganga.lindenlab.com/cgi-bin/login.cgi",
-	  "http://ganga-secondlife.webdev.lindenlab.com/helpers/" },
-	{ "Mitra",
-	  "util.mitra.lindenlab.com",
-	  "https://login.mitra.lindenlab.com/cgi-bin/login.cgi",
-	  "http://mitra-secondlife.webdev.lindenlab.com/helpers/" },
-	{ "Mohini",
-	  "util.mohini.lindenlab.com",
-	  "https://login.mohini.lindenlab.com/cgi-bin/login.cgi",
-	  "http://mohini-secondlife.webdev.lindenlab.com/helpers/" },
-  	{ "Nandi",
-	  "util.nandi.lindenlab.com",
-	  "https://login.nandi.lindenlab.com/cgi-bin/login.cgi",
-	  "http://nandi-secondlife.webdev.lindenlab.com/helpers/" },
-	{ "Parvati",
-	  "util.parvati.lindenlab.com",
-	  "https://login.parvati.lindenlab.com/cgi-bin/login.cgi",
-	  "http://parvati-secondlife.webdev.lindenlab.com/helpers/" },
-	{ "Radha",
-	  "util.radha.lindenlab.com",
-	  "https://login.radha.lindenlab.com/cgi-bin/login.cgi",
-	  "http://radha-secondlife.webdev.lindenlab.com/helpers/" },
-	{ "Ravi",
-	  "util.ravi.lindenlab.com",
-	  "https://login.ravi.lindenlab.com/cgi-bin/login.cgi",
-	  "http://ravi-secondlife.webdev.lindenlab.com/helpers/" },
-	{ "Siva", 
-	  "util.siva.lindenlab.com",
-	  "https://login.siva.lindenlab.com/cgi-bin/login.cgi",
-	  "http://siva-secondlife.webdev.lindenlab.com/helpers/" },
-	{ "Shakti",
-	  "util.shakti.lindenlab.com",
-	  "https://login.shakti.lindenlab.com/cgi-bin/login.cgi",
-	  "http://shakti-secondlife.webdev.lindenlab.com/helpers/" },
-	{ "Skanda",
-	  "util.skanda.lindenlab.com",
-	  "https://login.skanda.lindenlab.com/cgi-bin/login.cgi",
-	  "http://skanda-secondlife.webdev.lindenlab.com/helpers/" },
-	{ "Soma",
-	  "util.soma.lindenlab.com",
-	  "https://login.soma.lindenlab.com/cgi-bin/login.cgi",
-	  "http://soma-secondlife.webdev.lindenlab.com/helpers/" },
-	{ "Uma",
-	  "util.uma.lindenlab.com",
-	  "https://login.uma.lindenlab.com/cgi-bin/login.cgi",
-	  "http://uma-secondlife.webdev.lindenlab.com/helpers/" },
-	{ "Vaak",
-	  "util.vaak.lindenlab.com",
-	  "https://login.vaak.lindenlab.com/cgi-bin/login.cgi",
-	  "http://vaak-secondlife.webdev.lindenlab.com/helpers/" },
-	{ "Yami",
-	  "util.yami.lindenlab.com",
-	  "https://login.yami.lindenlab.com/cgi-bin/login.cgi",
-	  "http://yami-secondlife.webdev.lindenlab.com/helpers/" },
-	{ "Local", 
-	  "localhost", 
-	  "https://login.dmz.lindenlab.com/cgi-bin/login.cgi",
-	  "" },
-	{ "Other", 
-	  "", 
-	  "https://login.dmz.lindenlab.com/cgi-bin/login.cgi",
-	  "" }
-};
+unsigned char gMACAddress[MAC_ADDRESS_BYTES];		/* Flawfinder: ignore */
 
-const EGridInfo DEFAULT_GRID_CHOICE = GRID_INFO_AGNI;
+ LLViewerLogin::LLViewerLogin() :
+ 	mGridChoice(DEFAULT_GRID_CHOICE)
+ {
 
+	gridcount=0;
+	LLSD array = mGridList.emptyArray();
+	LLSD entry = mGridList.emptyMap();
+	entry.insert( "label", "None" );
+	entry.insert( "name", "" );
+	entry.insert( "login_uri", "" );
+	entry.insert( "helper_uri", "" );
+	entry.insert( "login_page", "" );
 
-unsigned char gMACAddress[MAC_ADDRESS_BYTES];		/* Flawfinder: ignore */
+	array.append( entry );
+	gridcount++;
+	
+	entry = mGridList.emptyMap();
+	entry.insert( "label", "Agni" );
+	entry.insert( "name", "util.agni.lindenlab.com" );
+	entry.insert( "login_uri", "https://login.agni.lindenlab.com/cgi-bin/login.cgi" );
+	entry.insert( "helper_uri", "https://secondlife.com/helpers/" );
+	entry.insert( "login_page", "http://secondlife.com/app/login/" );
+	array.append( entry );
+	gridcount++;
+	
+	mGridList.insert("grids", array );
+
+	// load the linden grids if available
+	loadGridsLLSD( gDirUtilp->getExpandedFilename(LL_PATH_APP_SETTINGS,"grids.xml") );
+	// see if we have a grids.xml file in "user_settings" to append
+	loadGridsLLSD( gDirUtilp->getExpandedFilename(LL_PATH_USER_SETTINGS,"grids.xml") );
+}
+
+void LLViewerLogin::loadGridsLLSD( std::string xml_filename )
+{
+	LLSD other_grids;
+	llifstream llsd_xml;
+	llsd_xml.open( xml_filename.c_str(), std::ios::in | std::ios::binary );
+	
+	if( llsd_xml.is_open()) {
+		llinfos << "Reading grid info: " << xml_filename << llendl;
+		LLSDSerialize::fromXML( other_grids, llsd_xml );
+        for(LLSD::map_iterator grid_itr = other_grids.beginMap(); 
+			             grid_itr != other_grids.endMap(); 
+			             ++grid_itr)
+        {
+			LLSD::String key_name = grid_itr->first;
+			LLSD grid_array = grid_itr->second;
+			llinfos << "reading: " << key_name << llendl;
+			if( grid_array.isArray()) {
+				for( int i = 0; i < grid_array.size(); i++ ) {
+					LLSD gmap = grid_array[i];
+					if( gmap.has("name") && gmap.has("label") && 
+							gmap.has("login_uri") && gmap.has("helper_uri" )) {
+						mGridList["grids"].append( gmap );
+						gridcount++;
+						llinfos << "Added grid: " << gmap.get("name") << llendl;
+					}
+					else {
+						if( gmap.has("name")) {
+							llwarns << "Incomplete grid definition: " << gmap.get("name")<<llendl;													
+						} else {
+							llwarns << "Incomplete grid definition: no name specified" << llendl;					
+						}
+					}
+				}
+			} else {
+				llwarns << "\"grids\" is not an array" << llendl;										
+			}
+		}
+	llsd_xml.close();
+	}	
+}
 
-LLViewerLogin::LLViewerLogin() :
-	mGridChoice(DEFAULT_GRID_CHOICE)
+void LLViewerLogin::setMenuColor() const
 {
+	if( mGridList["grids"][mGridChoice].has("menu_color")) {
+		std::string colorName = mGridList["grids"][mGridChoice].get("menu_color").asString();
+		LLColor4 color4;
+		LLColor4::parseColor( colorName.c_str(), &color4 );
+		if( color4 != LLColor4::black ) {
+			gMenuBarView->setBackgroundColor(color4);			
+		}
+	}
 }
 
-void LLViewerLogin::setGridChoice(EGridInfo grid)
+
+void LLViewerLogin::setGridChoice(int grid)
 {	
-	if(grid < 0 || grid >= GRID_INFO_COUNT)
+	if(grid < 0 || grid >= mGridList.get("grids").size())
 	{
-		llerrs << "Invalid grid index specified." << llendl;
+		llwarns << "Invalid grid index specified." << llendl;
+		grid = DEFAULT_GRID_CHOICE;
 	}
 
 	if(mGridChoice != grid || gSavedSettings.getS32("ServerChoice") != grid)
 	{
 		mGridChoice = grid;
-		if(GRID_INFO_LOCAL == mGridChoice)
+		if(mGridList.get("grids")[mGridChoice].get("label").asString() == "Local" )
 		{
 			mGridName = LOOPBACK_ADDRESS_STRING;
 		}
-		else if(GRID_INFO_OTHER == mGridChoice)
+		else if(getGridCount() == mGridChoice)
 		{
 			// *FIX:Mani - could this possibly be valid?
 			mGridName = "other"; 
 		}
 		else
 		{
-			mGridName = gGridInfo[mGridChoice].mLabel;
+			mGridName = mGridList.get("grids")[mGridChoice].get("label").asString();
+
 		}
 
 		gSavedSettings.setS32("ServerChoice", mGridChoice);
@@ -193,20 +171,20 @@ void LLViewerLogin::setGridChoice(const std::string& grid_name)
     {
         // find the grid choice from the user setting.
         int grid_index = GRID_INFO_NONE; 
-        for(;grid_index < GRID_INFO_OTHER; ++grid_index)
+        for(;grid_index < mGridList["grids"].size(); ++grid_index)
         {
-            if(0 == LLStringUtil::compareInsensitive(gGridInfo[grid_index].mLabel, grid_name))
+           if(mGridList["grids"][grid_index].get("label").asString()==grid_name.c_str())
             {
 				// Founding a matching label in the list...
-				setGridChoice((EGridInfo)grid_index);
+				setGridChoice(grid_index);
 				break;
             }
         }
 
-        if(GRID_INFO_OTHER == grid_index)
+        if(getGridCount() == grid_index)
         {
             // *FIX:MEP Can and should we validate that this is an IP address?
-            mGridChoice = GRID_INFO_OTHER;
+            mGridChoice = getGridCount();
             mGridName = grid_name;
 			gSavedSettings.setS32("ServerChoice", mGridChoice);
 			gSavedSettings.setString("CustomServer", mGridName);
@@ -221,7 +199,7 @@ void LLViewerLogin::resetURIs()
 	gSavedSettings.setString("CmdLineHelperURI", "");
 }
 
-EGridInfo LLViewerLogin::getGridChoice() const
+int LLViewerLogin::getGridChoice() const
 {
 	return mGridChoice;
 }
@@ -232,21 +210,37 @@ std::string LLViewerLogin::getGridLabel() const
 	{
 		return "None";
 	}
-	else if(mGridChoice < GRID_INFO_OTHER)
+	else if(mGridChoice < getGridCount())
 	{
-		return gGridInfo[mGridChoice].mLabel;
+		return mGridList["grids"][mGridChoice].get("label").asString();
 	}
 
 	return mGridName;
 }
 
-std::string LLViewerLogin::getKnownGridLabel(EGridInfo grid_index) const
+std::string LLViewerLogin::getGridPage() const
+{
+
+	
+	if(mGridChoice == GRID_INFO_NONE)
+	{
+		return "None";
+	}
+	else if(mGridChoice < getGridCount())
+	{
+		return mGridList["grids"][mGridChoice].get("login_page").asString();
+	}
+
+	return "None";
+}
+
+std::string LLViewerLogin::getKnownGridLabel(int grid_index) const
 {
-	if(grid_index > GRID_INFO_NONE && grid_index < GRID_INFO_OTHER)
+	if(grid_index > GRID_INFO_NONE && grid_index < getGridCount())
 	{
-		return gGridInfo[grid_index].mLabel;
+		return mGridList.get("grids")[grid_index].get("label").asString();
 	}
-	return gGridInfo[GRID_INFO_NONE].mLabel;
+	return mGridList.get("grids")[GRID_INFO_NONE].get("label").asString();
 }
 
 void LLViewerLogin::getLoginURIs(std::vector<std::string>& uris) const
@@ -283,9 +277,9 @@ void LLViewerLogin::getLoginURIs(std::vector<std::string>& uris) const
 	{
 		// If its a known grid choice, get the uri from the table,
 		// else try the grid name.
-		if(mGridChoice > GRID_INFO_NONE && mGridChoice < GRID_INFO_OTHER)
+		if(mGridChoice > GRID_INFO_NONE && mGridChoice < getGridCount())
 		{
-			uris.push_back(gGridInfo[mGridChoice].mLoginURI);
+			uris.push_back(mGridList["grids"][mGridChoice].get("login_uri").asString());
 		}
 		else
 		{
@@ -300,9 +294,9 @@ std::string LLViewerLogin::getHelperURI() const
 	if (helper_uri.empty())
 	{
 		// grab URI from selected grid
-		if(mGridChoice > GRID_INFO_NONE && mGridChoice < GRID_INFO_OTHER)
+		if(mGridChoice > GRID_INFO_NONE && mGridChoice < getGridCount())
 		{
-			helper_uri = gGridInfo[mGridChoice].mHelperURI;
+			helper_uri = mGridList["grids"][mGridChoice].get("helper_uri").asString();
 		}
 
 		if (helper_uri.empty())
diff --git a/indra/newview/llviewernetwork.h b/indra/newview/llviewernetwork.h
index 0bb298d..2573f0b 100644
--- a/indra/newview/llviewernetwork.h
+++ b/indra/newview/llviewernetwork.h
@@ -34,36 +34,7 @@
 #define LL_LLVIEWERNETWORK_H
 
 class LLHost;
-
-enum EGridInfo
-{
-	GRID_INFO_NONE,
-	GRID_INFO_ADITI,
-	GRID_INFO_AGNI,
-	GRID_INFO_ARUNA,
-	GRID_INFO_BHARATI,
-	GRID_INFO_CHANDRA,
-	GRID_INFO_DAMBALLAH,
-	GRID_INFO_DANU,
-	GRID_INFO_DURGA,
-	GRID_INFO_GANGA,
-	GRID_INFO_MITRA,
-	GRID_INFO_MOHINI,
-	GRID_INFO_NANDI,
-	GRID_INFO_PARVATI,
-	GRID_INFO_RADHA,
-	GRID_INFO_RAVI,
-	GRID_INFO_SIVA,
-	GRID_INFO_SHAKTI,
-	GRID_INFO_SKANDA,
-	GRID_INFO_SOMA,
-	GRID_INFO_UMA,
-	GRID_INFO_VAAK,
-	GRID_INFO_YAMI,
-	GRID_INFO_LOCAL,
-	GRID_INFO_OTHER, // IP address set via command line option
-	GRID_INFO_COUNT
-};
+class LLSD;
 
 /**
  * @brief A class to manage the viewer's login state.
@@ -74,7 +45,7 @@ class LLViewerLogin : public LLSingleton<LLViewerLogin>
 public:
 	LLViewerLogin();
 
-	void setGridChoice(EGridInfo grid);
+	void setGridChoice(const int grid);
 	void setGridChoice(const std::string& grid_name);
 	void resetURIs();
 
@@ -82,8 +53,10 @@ public:
 	* @brief Get the enumeration of the grid choice.
 	* Should only return values > 0 && < GRID_INFO_COUNT
 	**/
-	EGridInfo getGridChoice() const;
+	int getGridChoice() const;
 
+	int getGridCount() const { return gridcount; }
+	
 	/**
 	* @brief Get a readable label for the grid choice.
 	* Returns the readable name for the grid choice. 
@@ -91,17 +64,24 @@ public:
 	* the string used to specifiy the grid.
 	**/
 	std::string getGridLabel() const; 
+	std::string getGridPage() const;
 
-	std::string getKnownGridLabel(EGridInfo grid_index) const; 
+	std::string getKnownGridLabel(const int grid_index) const; 
 
 	void getLoginURIs(std::vector<std::string>& uris) const;
 	std::string getHelperURI() const;
 
 	bool isInProductionGrid();
 
+	void setMenuColor() const;
+	
+	void loadGridsLLSD( std::string filename );
+	
 private:
-	EGridInfo mGridChoice;
+	int gridcount;
+	int mGridChoice;
 	std::string mGridName;
+	LLSD mGridList;
 };
 
 const S32 MAC_ADDRESS_BYTES = 6;
-- 
tg: (1836a2b..) topic/features/jira-backported/VWR-7531-Dynamic-Grid-List (depends on: upstream)
